<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2002 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

  if (file_exists("functions.php"))
     include "functions.php";
  else if (file_exists("functions.php3"))
          include "functions.php3";
       else 
       {
          echo "no functions file. Error.";
          exit;
       }
  include "lnf-auth".$LNF_file_extension;

  if ($LNF_restricted_post==1)
     CheckHabilitation("Poster",$currenttopic);
  if ($LNF_site_restricted_access==1)
     CheckHabilitation("Reader",$currenttopic);

  include "lnf-utils-xml".$LNF_file_extension;

  // Check if the imputs are OK (not null nor full of blanks)
  if ((Valid_Input($nom)==FALSE))
  {
    header("Location: " . $url . "print".$LNF_file_extension."?art=".$art."&lnferror=".$display[$lang]["name"]." ".$display[$lang]["nottobenull"]);
    exit;
  }
  
  if ((Valid_Input($article)==FALSE))
  {
    header("Location: " . $url . "print".$LNF_file_extension."?art=".$art."&lnferror=".$display[$lang]["comments"]." ".$display[$lang]["nottobenull"]);
    exit;
  }
  
  // read all the file in a variable for faster search 
  $fic1=fopen($art,"r");
  $line=fread($fic1,filesize($art));
  fclose($fic1);

  // extract the email adress of the original poster
  $work_var_1=split("<email>",$line);
  $work_var_2=split("</email>",$work_var_1[1]);
  $email_original_poster=ereg_replace("_at_","@",$work_var_2[0]);

  // extract the title of the original news
  $work_var_3=split("<title>",$line);
  $news_title=split("</title>",$work_var_3[1]);
  
  $tabvers = phpversion();

  // 2 different algorithms to handle a different STRPOS behavior between".$LNF_file_extension." & PHP4
/*  switch ($tabvers[0])
  {
    // PHP4 STRPOS behavior
	case "4": 
	  // Seek of the beginning and the end of the answer to answer
	  $offsetBOAN = strpos($line,"<reply>\n<replyid>". $ans);  
	  if ($offsetBOAN===false)    
	  {
		 echo "problem with Begin Of Answer";
		 exit;
	  }

	  $offsetEOAN = strpos($line,"</reply>",$offsetBOAN);
	  if ($offsetEOAN===false) 
	  {
		 echo "problem with End OF Answer-1";
		 exit;
	  }
	  
	  $offsetLEVEL = strpos($line,"#",$offsetBOAN+1);  
	  if ($offsetLEVEL===false) 
	  {
		 echo "problem with LEVEL1";
		 exit;
	  }

	  $nextBOAN=$offsetBOAN;
	  $nextLEVEL=$offsetLEVEL;
	  $nextEOAN=$offsetEOAN;

	  $ok=1;
	  while ($ok==1) 
	  {
		$tempBOAN = strpos($line,"<reply>",$nextBOAN+1);  
		if ($tempBOAN===false) 
		{
		   $ok=2;
		   continue;
		}
	 
		$tempEOAN = strpos($line,"</reply>",$nextEOAN+1);  
		if ($tempEOAN===false) 
		{
		   $ok=3;
		   continue;
		}

		$tempLEVEL = strpos($line,"#",$tempBOAN+1);  
		if ($tempLEVEL===false) 
		{
		   $ok=4;
		   continue;
		}
		else  
		{
		   $lastsharp=strpos($line,"</replyid>",$tempLEVEL+1);
		   $extractedlevel=substr($line,$tempLEVEL+1,$lastsharp-($tempLEVEL+1));

		   if ($extractedlevel<$level) 
		   {
			  $ok=5;
			  continue;
		   }
		   
		   $nextLEVEL=$tempLEVEL;
		   $nextBOAN=$tempBOAN;
		   $nextEOAN=$tempEOAN;
		}
	  }
      break;

    // non PHP4 STRPOS behavior
	case "else":*/
	  // Seek of the beginning and the end of the answer to answer
	  $offsetBOAN = strpos($line,"<reply>\n<replyid>". $ans);  
	  if (is_string ($offsetBOAN) && !$offsetBOAN)    
	  {
		 echo "problem with Begin Of Answer";
		 exit;
	  }

	  $offsetEOAN = strpos($line,"</reply>",$offsetBOAN);
	  if (is_string ($offsetEOAN) && !$offsetEOAN) 
	  {
		 echo "problem with End OF Answer-1";
		 exit;
	  }
	  
	  $offsetLEVEL = strpos($line,"#",$offsetBOAN+1);  
	  if (is_string ($offsetLEVEL) && !$offsetLEVEL) 
	  {
		 echo "problem with LEVEL1";
		 exit;
	  }

	  $nextBOAN=$offsetBOAN;
	  $nextLEVEL=$offsetLEVEL;
	  $nextEOAN=$offsetEOAN;

	  $ok=1;
	  while ($ok==1) 
	  {
		$tempBOAN = strpos($line,"<reply>",$nextBOAN+1);  
		if (is_string ($tempBOAN) && !$tempBOAN) 
		{
		   $ok=2;
		   continue;
		}
	 
		$tempEOAN = strpos($line,"</reply>",$nextEOAN+1);  
		if (is_string ($tempEOAN) && !$tempEOAN) 
		{
		   $ok=3;
		   continue;
		}

		$tempLEVEL = strpos($line,"#",$tempBOAN+1);  
		if (is_string ($tempLEVEL) && !$tempLEVEL) 
		{
		   $ok=4;
		   continue;
		}
		else  
		{
		   $lastsharp=strpos($line,"</replyid>",$tempLEVEL+1);
		   $extractedlevel=substr($line,$tempLEVEL+1,$lastsharp-($tempLEVEL+1));

		   if ($extractedlevel<$level) 
		   {
			  $ok=5;
			  continue;
		   }
		   
		   $nextLEVEL=$tempLEVEL;
		   $nextBOAN=$tempBOAN;
		   $nextEOAN=$tempEOAN;
		}
	  }
/*	  break;
  }*/


  $firstpart=substr($line,0,$nextEOAN+9);
  $lastpart=substr($line,$nextEOAN+9);

  $dateinfic = getdateaffichage();
  $datefic = getdatefichier();

  //backup file
  $fic2=fopen($art.".bak","w+");
  fputs($fic2,$line);
  fclose($fic2);

  $fic=fopen($art,"w+");

  // write first part of the original message
  fputs($fic,$firstpart);

  //write the answer at the right place in the message 
  fputs($fic,"<reply>\n");
  fputs($fic,"<replyid>" . htmlspecialchars($nom) ."-" . $datefic . "#" . $level ."</replyid>\n");
  $email = ereg_replace("@","_at_",$email);   
  fputs($fic,"<replyemail>". htmlspecialchars($email) . "</replyemail>\n");
  fputs($fic,"<replyauthor>" . htmlspecialchars($nom) . "</replyauthor>\n");
  fputs($fic,"<replydate>".$dateinfic."</replydate>\n");
  fputs($fic,"<replybody>\n" . htmlspecialchars($article) . "\n</replybody>\n");
  fputs($fic,"</reply>\n");

  // write the second part of the original message
  fputs($fic,$lastpart);

  fclose($fic);

  // delete the backup file.
  unlink($art . ".bak");

  // send a notification to the original poster
  //   when an answer is written to his news.
  if ((ValidEmailAdress($email_original_poster)) && ($LNF_reply_notification==1))
  {
     mail ($email_original_poster,"[" . $news_title[0] . "] ". $display[$lang]["answer"] . " - ". $display[$lang]["author"] .": " . $nom, $display[$lang]["readandanswer"] . ":\n" . $url."print".$LNF_file_extension."?art=".$art, "From: lnfnotification@yoursite.com");
  }
  
  header("Location: " . $url . "print".$LNF_file_extension."?art=" . $art);

?>