<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2003 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

// Save an article when is modified in moderation/"manage news" phase
//
Function SaveXMLArticle($art, $titre, $corps, $email, $nom, $date, $newtopic, $link, $linktext, $fromwhere)
{

  $curtopic=GetTopic($art);
  if ($curtopic==$newtopic) 
  {
     $changetopic=0;
     $newart=$art;
  }
  else
  {
     // topic has been changed
     $changetopic=1;
     $newart=ereg_replace( $curtopic, $newtopic, $art);
  }

  switch ($fromwhere)
  {
    case "moderate":
         // 
         if ($curtopic==$newtopic) 
            $fic = fopen($art,"w+");
         else
            $fic = fopen($newart,"w+");

         fputs($fic,"<"."?xml version='1.0' standalone='yes' ?".">\n<!-- LNF_message_version='3.1' -->\n<news>\n");
         fputs($fic,"<title>".htmlspecialchars(cleaning_input($titre)) ."</title>\n");
         fputs($fic,"<email>".htmlspecialchars(cleaning_input($email)) ."</email>\n");
         fputs($fic,"<author>".htmlspecialchars(cleaning_input($nom)) ."</author>\n");
         fputs($fic,"<date>".htmlspecialchars(cleaning_input($date)) ."</date>\n");
         fputs($fic,"<body>\n");
         if (strrpos($corps,"\n")==strlen($corps)) 
            fputs($fic,htmlspecialchars(cleaning_input($corps)));
         else
            fputs($fic,htmlspecialchars(cleaning_input($corps))."\n");
         fputs($fic,"</body>\n");
         
         // check if links come from the web form and have to be written in the newsfile
         $links_tab_size=sizeof($link);
         $linkstexts_tab_size=sizeof($linktext);
         $i=0;
         
         if (($links_tab_size>0) and ($linkstexts_tab_size)>0)
         {
             fputs($fic,"<linksection>\n");
             while(($i<$links_tab_size) and ($i<$linkstexts_tab_size))
             {
               $line = "<linkitem>\n<link>";
               $line = $line . cleaning_input($link[$i]);
               $line = $line . "</link>\n<linktext>";
               $line = $line . cleaning_input($linktext[$i]);
               $line = $line . "</linktext>\n</linkitem>\n";
               fputs($fic,$line);
               $i++;
             }
             fputs($fic,"</linksection>\n</news>\n");
         }
         else
             fputs($fic,"</news>\n");
         fclose($fic); 

         // file with old topic is deleted
         if ($curtopic!=$newtopic) 
            unlink($art);

         break;

    case "manage":
         $fic = fopen($art . "bak","w+");
         fputs($fic,"<"."?xml version='1.0' standalone='yes' ?".">\n<!-- LNF_message_version='3.2' -->\n<news>\n");
         fputs($fic,"<title>".htmlspecialchars(cleaning_input($titre)) ."</title>\n");
         fputs($fic,"<email>".htmlspecialchars(cleaning_input($email)) ."</email>\n");
         fputs($fic,"<author>".htmlspecialchars(cleaning_input($nom)) ."</author>\n");
         fputs($fic,"<date>".htmlspecialchars(cleaning_input($date)) ."</date>\n");
         fputs($fic,"<body>\n");
         if (strrpos($corps,"\n")==strlen($corps)) 
            fputs($fic,htmlspecialchars(cleaning_input($corps)));
         else
            fputs($fic,htmlspecialchars(cleaning_input($corps))."\n");
         fputs($fic,"</body>\n");

         // check if links come from the web form and have to be written in the newsfile
         $links_tab_size=sizeof($link);
         $linkstexts_tab_size=sizeof($linktext);
         $i=0;
         $links_in_URL=0;
         
         if (($links_tab_size>0) and ($linkstexts_tab_size)>0)
         {
             fputs($fic,"<linksection>\n");
             while(($i<$links_tab_size) and ($i<$linkstexts_tab_size))
             {
               $line = "<linkitem>\n<link>";
               $line = $line . cleaning_input($link[$i]);
               $line = $line . "</link>\n<linktext>";
               $line = $line . cleaning_input($linktext[$i]);
               $line = $line . "</linktext>\n</linkitem>\n";
               fputs($fic,$line);
               $i++;
             }
             fputs($fic,"</linksection>\n");
             $links_in_URL = 1;
         }

         $go=0;
         
         /* $fd=fopen($art,"r");
         $contents = fread( $fd, 100000);
         fclose( $fd ); 
         $link_exists_in_news=strpos($contents, "<linksection>");*/ 

         $fic2 = fopen($art,"r");
         $ligne = fgets($fic2,16000); 
         $ligne = ereg_replace("\n","",$ligne);   
         while (!feof($fic2))
         {
           $tab = explode(">",$ligne);
           switch ($tab[0])
           {
             case "</body":
                  // if no linksection exists in the URL, 
                  // we begin to copy the file content after the text body.
                  if ($links_in_URL == 0)
                     $go=1; 
                  break;
                  
             case "</linksection":
                  // if a linksection already exists in the URL, 
                  // we skip the previous linksection and begin to copy the file content 
                  // after this previous link section.
                  $go = 1;
                  break;

             default:
                  if ($go==1) 
                    fputs($fic,$ligne);
                  break;
           }

           $ligne = fgets($fic2,16000); 
         }
         fclose($fic2); 
         fclose($fic); 
    
         unlink($art);
         rename($art . "bak",$art);
         break;

    default:
         break;
  }
  //  Put general Read and Write perms
  $oldumask = umask(0);
  chmod($newart,0666);
  umask($oldumask); 
  return $newart;
}

?>