<?php
//    LaNewsFactory - web news engine written in PHP
//    Copyright (C) 2000-2002 Christophe Brocas - christophe.brocas@free.fr
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

if (file_exists("functions.php"))
   include "functions.php";
else if (file_exists("functions.php3"))
         include "functions.php3";
       else 
       {
         echo "no functions file. Error.";
         exit;
       }

include "lnf-auth".$LNF_file_extension;
include "lnf-utils-xml".$LNF_file_extension;
include "lnf-display-xml".$LNF_file_extension;

if ($LNF_site_restricted_access==1)
   CheckHabilitation("Reader",$currenttopic);

include "menu".$LNF_file_extension;

if (($way==1)&&($currenttopic=="AllTopics")) 
  $tab = ListDirInArray(".xml","news");
else
  $tab = ListDirInArray("-$currenttopic.xml","news");

if (sizeof($tab) >0) 
{
  rsort($tab);
  $limit = sizeof($tab);

  $tplArt = new FastTemplate("templates/$LNF_template"); 
  $tplArt->define( array( table      => "table.tpl", 
                          row        => "row.tpl", 
                          line       => "line.tpl", 
                          colour0    => "colour0.tpl",
                          colour1    => "colour1.tpl",
                          colour2    => "colour2.tpl",
                          td         => "td.tpl") ); 

  $tplArt->assign(LNF_TD_WIDTH,"45%");
  $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["searchresults"] . " \"" . $query . "\""."</b>");
  $tplArt->parse(LNF_ROW,"td");
  $tplArt->assign(LNF_TD_WIDTH,"15%");
  $tplArt->assign(LNF_TD_CONTENT,"&nbsp");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->assign(LNF_TD_WIDTH,"20%");
  $tplArt->assign(LNF_TD_CONTENT,"&nbsp");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->assign(LNF_TD_WIDTH,"20%");
  $tplArt->assign(LNF_TD_CONTENT,"&nbsp");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
  $tplArt->parse(LNF_TABLE_ROWS,".row");

  $tplArt->assign(LNF_TD_WIDTH,"45%");
  $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["title"]."</b>");
  $tplArt->parse(LNF_ROW,"td");
  $tplArt->assign(LNF_TD_WIDTH,"15%");
  $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["topic"]."</b>");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->assign(LNF_TD_WIDTH,"20%");
  $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["author"]."</b>");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->assign(LNF_TD_WIDTH,"20%");
  $tplArt->assign(LNF_TD_CONTENT,"<b>".$display[$lang]["postdate"]."</b>");
  $tplArt->parse(LNF_ROW,".td");
  $tplArt->parse(LNF_BACKGROUND_COLOR,"colour2");
  $tplArt->parse(LNF_TABLE_ROWS,".row");

  $nbdisplay=0;
  for($i=0; $i<$limit; $i++)
  {
    $fic1=fopen("news/".$tab[$i],"r");
    $line=fread($fic1,filesize("news/".$tab[$i]));
    fclose($fic1);

    $indcolor=0;
    
    if ( eregi( $query, $line, $regs ) )
    {

      $file=explode("-", $tab[$i]);
      $topic=explode(".", $file[2]);

      $rtab=DisplayXMLShortMod("news/".$tab[$i],$i,0,"print".$LNF_file_extension);
      $tplArt->assign(LNF_TD_WIDTH,"45%");
      $tplArt->assign(LNF_TD_CONTENT,$rtab[0]);
      $tplArt->parse(LNF_ROW,"td");
      $tplArt->assign(LNF_TD_WIDTH,"15%");
      $tplArt->assign(LNF_TD_CONTENT,$topic[0]);
      $tplArt->parse(LNF_ROW,".td");
      $tplArt->assign(LNF_TD_WIDTH,"20%");
      $tplArt->assign(LNF_TD_CONTENT,$rtab[1]);
      $tplArt->parse(LNF_ROW,".td");
      $tplArt->assign(LNF_TD_WIDTH,"20%");
      $tplArt->assign(LNF_TD_CONTENT,$rtab[2]);
      $tplArt->parse(LNF_ROW,".td");
      $tplArt->parse(LNF_BACKGROUND_COLOR,"colour".$indcolor);
      $tplArt->parse(LNF_TABLE_ROWS,".row");

      $nbdisplay++;
      if ($indcolor==0) 
         $indcolor=1;
      else
         $indcolor=0;

      // 10 max. messages returned
          if ($nbdisplay==10) 
             break;
    }
  }

 
  $tplArt->assign(LNF_TABLE_WIDTH,"95%");
  $tplArt->parse(FINAL,"table");
  $tplArt->FastPrint(FINAL);



}
else
  echo $display[$lang]["nonews"] . ".";

include "tail".$LNF_file_extension;
?>